<template>
  <v-dialog
    v-if="size === 'compact'"
    v-model="dialog"
    :scrim="false"
    :absolute="true"
    class="top-10"
    :close-on-content-click="false"
    :contained="true"
  >
    <template #activator="{ props }">
      <svn-pro-button
        v-bind="props"
        variant="text"
        :text="currentFontLabel"
      />
    </template>

    <template #default>
      <div class="flex flex-col gap-2 py-2 rounded-[4px] w-[200px] min-w-[112px] cardShadow bg-surface">
        <v-list
          v-for="group in FONT_FAMILY_GROUPS"
          :key="`${group?.label}`"
          color="primary"
          density="compact"
          class="rounded-none bg-surface py-0 max-h-[496px]"
        >
          <div class="w-full flex flex-col items-start">
            <v-list-item class="w-full">
              <span class="text-[16px] leading-6 tracking-[0.5px] font-medium text-onSurface">
                {{ group.label }}
              </span>
            </v-list-item>
  
            <v-list-item
              v-for="font in group.options"
              :key="`${font.label}_${font.value}`"
              :value="`${font.label}_${font.value}`"
              :active="font?.label === currentFontLabel"
              class="w-full"
              @click="selectFont(font.value, $event)"
            >
              <svn-pro-text bodyLarge regular :style="{ fontFamily: `${font.value} !important` }">
                {{ font.label }}
              </svn-pro-text>
            </v-list-item>
          </div>
        </v-list>
      </div>
    </template>
  </v-dialog>

  <Popover v-else class="relative">
    <PopoverButton>
      <svn-pro-button
        variant="text"
        :text="currentFontLabel"
      />
    </PopoverButton>

    <PopoverPanel class="absolute z-10 bg-surface">
      <div class="flex flex-col gap-2 py-2 rounded-[4px] w-[200px] max-h-[496px] min-w-[112px] h-full cardShadow overflow-y-auto">
        <v-list
          v-for="group in FONT_FAMILY_GROUPS"
          :key="`${group?.label}`"
          color="primary"
          density="compact"
          class="rounded-none bg-surface py-0"
        >
          <div class="w-full flex flex-col items-start">
            <v-list-item class="w-full">
              <span class="text-[16px] leading-6 tracking-[0.5px] font-medium text-onSurface">
                {{ group.label }}
              </span>
            </v-list-item>
  
            <v-list-item
              v-for="font in group.options"
              :key="`${font.label}_${font.value}`"
              :value="`${font.label}_${font.value}`"
              :active="font?.label === currentFontLabel"
              class="w-full"
              @click="selectFont(font.value, $event)"
            >
              <svn-pro-text bodyLarge regular :style="{ fontFamily: `${font.value} !important` }">
                {{ font.label }}
              </svn-pro-text>
            </v-list-item>
          </div>
        </v-list>
      </div>
    </PopoverPanel>
  </Popover>
</template>

<script setup>
import { watch, ref, onMounted } from 'vue';
import SvnProText from '../../styles/SvnProText.vue';
import SvnProButton from '../../button/SvnProButton.vue';
import { Popover, PopoverButton, PopoverPanel } from '@headlessui/vue'

const props = defineProps({
  value: { type: String, default: '' },
  size: { type: String, default: null },
})

onMounted(() => {
  currentValue.value = FONT_FAMILIES.find(size => size.value === props.value)
  currentFontLabel.value = currentValue?.value?.label || 'Work Sans'
})

const emit = defineEmits(['select-font']);

const dialog = ref(false);
const currentValue = ref({});
const currentFontLabel = ref(null);

const FONT_FAMILY_GROUPS = [
  {
    label: 'Sans Serif',
    options: [
      { label: 'Work Sans', value: 'Work Sans' },
      { label: 'Arial', value: 'Arial' },
      { label: 'Helvetica', value: 'Helvetica' },
    ],
  },
  {
    label: 'Serif',
    options: [
      { label: 'Times New Roman', value: 'Times' },
      { label: 'Garamond', value: 'Garamond' },
      { label: 'Georgia', value: 'Georgia' },
    ],
  },
  {
    label: 'Monospace',
    options: [
      { label: 'Courier', value: 'Courier' },
      { label: 'Courier New', value: 'Courier New' },
    ],
  },
]
const FONT_FAMILIES = FONT_FAMILY_GROUPS.flatMap(group => [group.options]).flat()

const selectFont = (font, e) => {
  if (e) {
    e.preventDefault()
    e.stopPropagation()
    emit('select-font', font)
  }
}

watch(props, (newValue, oldValue) => {
  if (newValue.value) {
    currentValue.value = FONT_FAMILIES.find(size => size.value === props.value)
    currentFontLabel.value = currentValue?.value?.label || 'Work Sans'
  }
})
</script>

<style scoped>
.cardShadow {
  box-shadow: 0px 2px 2px 0px rgba(0, 0, 0, 0.14), 0px 3px 1px 0px rgba(0, 0, 0, 0.12), 0px 1px 5px 0px rgba(0, 0, 0, 0.20);
}
</style>